<?php

// $Id: media_mover_api_menus.inc,v 1.1.2.1 2008/10/30 13:13:20 arthuregg Exp $

/**
 * contains all the menu functions for the module
 * @return array
 */
function media_mover_api_menus($maycache) {
	global $user;
 
  // main page
  $items[] = array(
    'path' => 'admin/media_mover',
    'title' => t('Media Mover'),
    'callback' => 'media_mover_api_page',
    'access' => user_access('administer media_mover'),
    'type' => MENU_NORMAL_ITEM,
  );
  
  // ------------------------------------------------
  // MAIN TABS for admin/media_mover
  
  // main page
  $items[] = array(
    'path' => 'admin/media_mover/default',
    'title' => t('Overview'),
    'callback' => 'media_mover_api_page',
    'access' => user_access('administer media_mover'),
    'type' => MENU_DEFAULT_LOCAL_TASK,
    'weight' => -10,
  );

  // settings as a tab
  $items[] = array(
    'path' => 'admin/media_mover/settings',
    'title' => t('Settings'),
    'callback' => 'drupal_get_form',
    'callback arguments' => array('media_mover_api_admin_settings'),
    'access' => user_access('administer media_mover'),
    'type' => MENU_LOCAL_TASK,
  );

  // settings in the normal place
  $items[] = array(
    'path' => 'admin/settings/media_mover',
    'title' => t('Media Mover admin settings'),
    'description' => t('Configure default settings for Media Mover modules.'),
    'callback' => 'drupal_get_form',
    'callback arguments' => array('media_mover_api_admin_settings'),
    'access' => user_access('administer media_mover'),
  );
 
  // add a new configuration
  $items[] = array(
    'path' => 'admin/media_mover/config/add',
    'title' => t('Add Config'),
    'callback' => 'drupal_get_form',
    'access' => user_access('administer media_mover'),
    'callback arguments' => array('media_mover_api_add_config_form', arg(4)),
    'type' => MENU_LOCAL_TASK,
  );    
  
  // show all files
  $items[] = array(
    'path' => 'admin/media_mover/files',
    'title' => t('All Files'),
    'callback' => 'media_mover_api_files_list',
    'callback arguments' => array(arg(3)),
    'access' => user_access('administer media_mover'),
    'type' => MENU_LOCAL_TASK,
    'weight' => -9,
  );      
 
  // files status
  $items[] = array(
    'path' => 'admin/media_mover/files/status',
    'title' => t('File Status'),
    'callback' => 'media_mover_api_files_status',
    'access' => user_access('administer media_mover'),
    'type' => MENU_LOCAL_TASK,
  );
 
  // import a configuration
  $items[] = array(
    'path' => 'admin/media_mover/import',
    'title' => t('Import'),
    'callback' => 'media_mover_api_import_config',
    'access' => user_access('administer media_mover'),
    'type' => MENU_LOCAL_TASK,
    'weight' => 10,
  );
  
  // export a configuration
  $items[] = array(
    'path' => 'admin/media_mover/export',
    'title' => t('Export'),
    'callback' => 'media_mover_api_export',
    'access' => user_access('administer media_mover'),
    'type' => MENU_LOCAL_TASK,
    'weight' => 10,
  );
  
  // -------------------------------------------------------
  // Individual Configuration functions

  // only add these to the menu if we're on a config page    
  if (arg(2) == 'config' && is_numeric(arg(3))) {
  
    // landing page for an individual configuration
    $items[] = array(
      'path' => 'admin/media_mover/config/'. arg(3),
      'title' => t('View'),
      'callback' => 'media_mover_api_configuration_view',
      'access' => user_access('administer media_mover'),
      'callback arguments' => array(arg(3)),
      'type' => MENU_DEFAULT_LOCAL_TASK,
      'weight' => -9,
    );
   
    // landing page for an individual configuration
    $items[] = array(
      'path' => 'admin/media_mover/config/'. arg(3) .'/view',
      'title' => t('Details'),
      'callback' => 'media_mover_api_configuration_view',
      'access' => user_access('administer media_mover'),
      'callback arguments' => array(arg(3)),
      'type' => MENU_LOCAL_TASK,
      'weight' => -10,
    );
           
    // edit tab for a configuration
    $items[] = array(
      'path' => 'admin/media_mover/config/'. arg(3) .'/edit',
      'title' => t('Edit'),
      'callback' => 'drupal_get_form',
      'access' => user_access('administer media_mover'),
      'callback arguments' => array('media_mover_api_config_edit_form', arg(3)),
      'type' => MENU_LOCAL_TASK,
    );
    
    // file tab for a configuration
    $items[] = array(
      'path' => 'admin/media_mover/config/'. arg(3) .'/files',
      'title' => t('Files'),
      'callback' => 'media_mover_api_files_list',
      'access' => user_access('administer media_mover'),
      'callback arguments' => array(arg(3)),
      'type' => MENU_LOCAL_TASK,
    );

    // clear non finished files for a config
    $items[] = array(
      'path' => 'admin/media_mover/config/'. arg(3) .'/files/clear',
      'title' => t('Files'),
      'callback' => 'media_mover_api_config_files_clear',
      'access' => user_access('administer media_mover'),
      'callback arguments' => array(arg(3)),
      'type' => MENU_LOCAL_TASK,
    );
  
    // run tab for a configuration
    $items[] = array(
      'path' => 'admin/media_mover/config/'. arg(3) .'/run',
      'title' => t('Run'),
      'callback' => 'media_mover_api_run_configuration',
      'access' => user_access('administer media_mover'),
      'callback arguments' => array(arg(3)),
      'type' => MENU_LOCAL_TASK,
    );
  }
    
  // delete an existing configuration
  $items[] = array(
    'path' => 'admin/media_mover/config/'. arg(3) .'/delete',
    'title' => t('Confirm Configuration Deletion'),
    'callback' => 'drupal_get_form',
    'access' => user_access('administer media_mover'),
    'callback arguments' => array('media_mover_api_config_delete_confirm', arg(3)),
    'type' => MENU_CALLBACK,
  );
  
  // Empty an existing configuration of files
  $items[] = array(
    'path' => 'admin/media_mover/config/'. arg(3) .'/empty',
    'title' => t('Confirm Configuration Deletion'),
    'callback' => 'drupal_get_form',
    'access' => user_access('administer media_mover'),
    'callback arguments' => array('media_mover_api_config_empty_confirm', arg(3)),
    'type' => MENU_CALLBACK,
  );
  
  // -------------------------------------------------------
  // Configuration tasks
  
  // change a configuration status  
  $items[] = array(
    'path' => 'admin/media_mover/config/'. arg(3). '/status/'. arg(5),
    'title' => t('Update configuration status'),
    'callback' => 'drupal_get_form',
    'access' => user_access('administer media_mover'),
    'type' => MENU_CALLBACK,
    'callback arguments' => array('media_mover_api_config_status_change', arg(3), arg(5) ),
  );
   
  // -------------------------------------------------------
  // File tasks
  
  // edit a file
  $items[] = array(
    'path' => 'admin/media_mover/file/edit',
    'title' => t('Edit File'),
    'callback' => 'drupal_get_form',
    'access' => user_access('administer media_mover'),
    'type' => MENU_CALLBACK,
    'callback arguments' => array('media_mover_api_edit_file_form', arg(4)),
  );

  // delete a file
  $items[] = array(
    'path' => 'admin/media_mover/file/delete',
    'title' => t('Delete File'),
    'callback' => 'drupal_get_form',
    'access' => user_access('administer media_mover'),
    'type' => MENU_CALLBACK,
    'callback arguments' => array('media_mover_api_file_delete_confirm_form', arg(4)),
  );
        
  // -------------------------------------------------------
  // File tasks
  
  $items[] = array(
    'path' => 'media_mover/rerun/'. arg(2) .'/node',
    'title' => t('Rerun process'),
    'callback' => 'drupal_get_form',
    'access' => user_access('administer media_mover'),
    'type' => MENU_CALLBACK,
    'callback arguments' => array('media_mover_api_rerun_node_form', arg(2), arg(4)),
  );
  
  return $items;
	
}